<?php

/**
 * This is the model class for table "category".
 *
 * The followings are the available columns in table 'category':
 * @property integer $id
 * @property string $title
 * @property string $en_title
 * @property string $language
 * @property integer $create_datetime
 * @property integer $update_datetime
 * @property integer $parent_id
 * @property string $icon
 *
 * The followings are the available model relations:
 * @property Category $parent
 * @property Category[] $categories
 */
Yii::import('admin.models.behaviors.category-behavior.*');

class Category extends FlexActiveRecord {

    private $_url;

    /**
     * @return string the associated database table name
     */
    public function tableName() {
        return 'category';
    }

    public function beforeValidate() {
        if ($this->isNewRecord) {
            // set the create date, last updated date and the user doing the creating  
            $this->create_datetime = time();
            $this->update_datetime = time();
        } else {
            //not a new record, so just set the last updated time and last updated user id     
            $this->update_datetime = time();
        }
        return parent::beforeValidate();
    }

    public function setAttributes($values, $safeOnly = true) {
        if (isset($values['slug']) && isset($values['title'])) {
            $slug = trim($values['slug']);
            $title = trim($values['title']);

            if (strlen($slug) === 0) {
                $values['slug'] = Common::sanitize($title);
            }
        }

        parent::setAttributes($values, $safeOnly);
    }

    /**
     * @return array validation rules for model attributes.
     */
    public function rules() {
        // NOTE: you should only define rules for those attributes that
        // will receive user inputs.
        return array(
            array('title, create_datetime, update_datetime', 'required'),
            array('create_datetime, update_datetime, parent_id', 'numerical', 'integerOnly' => true),
            array('title', 'length', 'max' => 100),
            array('en_title', 'length', 'max'=>300),
            array('language', 'length', 'max' => 2),
            array('icon', 'length', 'max'=>500),
            array('slug', 'safe'),
            // The following rule is used by search().
            // @todo Please remove those attributes that should not be searched.
            array('id, title, language, create_datetime, update_datetime, parent_id, icon,en_title', 'safe', 'on' => 'search'),
        );
    }

    /**
     * @return array relational rules.
     */
    public function relations() {
        // NOTE: you may need to adjust the relation name and the related
        // class name for the relations automatically generated below.
        return array(
            'parent' => array(self::BELONGS_TO, 'Category', 'parent_id'),
            'categories' => array(self::HAS_MANY, 'Category', 'parent_id'),
			'articles' => array(self::MANY_MANY, 'Article', '{{article_has_category}}(article_id,category_id)','order'=>'articles.create_datetime DESC',),
        );
    }

    public function scopes() {
        return array(
            'filterLanguage' => array(
                'condition' => "t.language='" . Yii::app()->language . "'",
            ),
        );
    }

    /**
     * @return array customized attribute labels (name=>label)
     */
    public function attributeLabels() {
        return array(
            'id' => Yii::t('admin', 'ID'),
            'title' => Yii::t('admin', 'Title'),
            'en_title' => Yii::t('admin','En Title'),
            'language' => Yii::t('admin', 'Language'),
            'create_datetime' => Yii::t('admin', 'Create Datetime'),
            'update_datetime' => Yii::t('admin', 'Update Datetime'),
            'parent_id' => Yii::t('admin', 'Parent'),
            'icon' => Yii::t('admin','Icon'),
        );
    }

    /**
     * Retrieves a list of models based on the current search/filter conditions.
     *
     * Typical usecase:
     * - Initialize the model fields with values from filter form.
     * - Execute this method to get CActiveDataProvider instance which will filter
     * models according to data in model fields.
     * - Pass data provider to CGridView, CListView or any similar widget.
     *
     * @return CActiveDataProvider the data provider that can return the models
     * based on the search/filter conditions.
     */
    public function search() {
        // @todo Please modify the following code to remove attributes that should not be searched.

        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('title', $this->title, true);
        $criteria->compare('en_title',$this->en_title,true);
        $criteria->compare('language', $this->language, true);
        $criteria->compare('create_datetime', $this->create_datetime);
        $criteria->compare('update_datetime', $this->update_datetime);
        $criteria->compare('parent_id', $this->parent_id);
        $criteria->compare('icon',$this->icon,true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

    /**
     * Returns the static model of the specified AR class.
     * Please note that you should have this exact method in all your CActiveRecord descendants!
     * @param string $className active record class name.
     * @return Category the static model class
     */
    public static function model($className = __CLASS__) {
        return parent::model($className);
    }

    public function behaviors() {
        return array(
            'CategoryBehavior' => array(
                'class' => 'DCategoryTreeBehavior',
                'titleAttribute' => 'title',
                'aliasAttribute' => 'slug',
                'defaultCriteria' => array(
                    'order' => 't.title ASC'
                ),
            ),
            'activerecord-relation' => array(
                'class' => 'EActiveRecordRelationBehavior',
            )
        );
    }
    public function getArticleByCategory($category_slug){
         $category = Category::model()->findByAttributes(array('slug'=>$category_slug));
       //  var_dump($category);
        $criteria = new CDbCriteria(array('scopes' => array('published', 'filterLanguage'),'order' => 't.create_datetime DESC'));
        $criteria->together = true;
        $criteria->with = array('categories' => array('select' => 'id'));
        $criteria->compare('categories.id', $category->id);

      
            

        /*$dataProvider = new CActiveDataProvider('Article', array(
            'criteria' => $criteria,
            'pagination' => array(
                'pageSize' => 100
            ),
        ));*/
        $dataProvider =  Article::model()->findAll($criteria);
        
        return $dataProvider;
    }
	 public function getArticleByCategory_limit($category_slug,$limit=4){
         $category = Category::model()->findByAttributes(array('slug'=>$category_slug));
       //  var_dump($category);
        $criteria = new CDbCriteria(array('scopes' => array('published', 'filterLanguage'),'order' => 't.create_datetime DESC','limit'=>$limit));
        $criteria->together = true;
        $criteria->with = array('categories' => array('select' => 'id'));
        $criteria->compare('categories.id', $category->id);

      
            

        /*$dataProvider = new CActiveDataProvider('Article', array(
            'criteria' => $criteria,
            'pagination' => array(
                'pageSize' => 100
            ),
        ));*/
        $dataProvider =  Article::model()->findAll($criteria);
        
        return $dataProvider;
    }
    // Generates URL. Use simple `$model->url` instead of `Yii::app()->createUrl(...)`;
    public function getUrl() {
        if ($this->_url === null) {
            $this->_url = Yii::app()->createUrl('article/category', array('slug' => $this->slug));
        }
        return $this->_url;
    }
 

}
